# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageActionRunProjectionContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'provider': 'str',
        'metadata': 'object',
        'project_id': 'str',
        'action_id': 'str',
        'run_state': 'str',
        'action_type': 'str',
        'run_project_id': 'str',
        'triggered_by': 'str',
        'created_millis': 'int',
        'start_time_millis': 'int',
        'end_time_millis': 'int',
        'ebs_event_id': 'str',
        'action_version_id': 'str',
        'action_version_name': 'str',
        'name': 'str',
        'runtime': 'str',
        'id': 'str'
    }

    attribute_map = {
        'provider': 'provider',
        'metadata': 'metadata',
        'project_id': 'projectId',
        'action_id': 'actionId',
        'run_state': 'runState',
        'action_type': 'actionType',
        'run_project_id': 'runProjectId',
        'triggered_by': 'triggeredBy',
        'created_millis': 'createdMillis',
        'start_time_millis': 'startTimeMillis',
        'end_time_millis': 'endTimeMillis',
        'ebs_event_id': 'ebsEventId',
        'action_version_id': 'actionVersionId',
        'action_version_name': 'actionVersionName',
        'name': 'name',
        'runtime': 'runtime',
        'id': 'id'
    }

    def __init__(self, provider=None, metadata=None, project_id=None, action_id=None, run_state=None, action_type=None, run_project_id=None, triggered_by=None, created_millis=None, start_time_millis=None, end_time_millis=None, ebs_event_id=None, action_version_id=None, action_version_name=None, name=None, runtime=None, id=None):  # noqa: E501
        """PageActionRunProjectionContent - a model defined in Swagger"""  # noqa: E501
        self._provider = None
        self._metadata = None
        self._project_id = None
        self._action_id = None
        self._run_state = None
        self._action_type = None
        self._run_project_id = None
        self._triggered_by = None
        self._created_millis = None
        self._start_time_millis = None
        self._end_time_millis = None
        self._ebs_event_id = None
        self._action_version_id = None
        self._action_version_name = None
        self._name = None
        self._runtime = None
        self._id = None
        self.discriminator = None
        if provider is not None:
            self.provider = provider
        if metadata is not None:
            self.metadata = metadata
        if project_id is not None:
            self.project_id = project_id
        if action_id is not None:
            self.action_id = action_id
        if run_state is not None:
            self.run_state = run_state
        if action_type is not None:
            self.action_type = action_type
        if run_project_id is not None:
            self.run_project_id = run_project_id
        if triggered_by is not None:
            self.triggered_by = triggered_by
        if created_millis is not None:
            self.created_millis = created_millis
        if start_time_millis is not None:
            self.start_time_millis = start_time_millis
        if end_time_millis is not None:
            self.end_time_millis = end_time_millis
        if ebs_event_id is not None:
            self.ebs_event_id = ebs_event_id
        if action_version_id is not None:
            self.action_version_id = action_version_id
        if action_version_name is not None:
            self.action_version_name = action_version_name
        if name is not None:
            self.name = name
        if runtime is not None:
            self.runtime = runtime
        if id is not None:
            self.id = id

    @property
    def provider(self):
        """Gets the provider of this PageActionRunProjectionContent.  # noqa: E501


        :return: The provider of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this PageActionRunProjectionContent.


        :param provider: The provider of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._provider = provider

    @property
    def metadata(self):
        """Gets the metadata of this PageActionRunProjectionContent.  # noqa: E501


        :return: The metadata of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this PageActionRunProjectionContent.


        :param metadata: The metadata of this PageActionRunProjectionContent.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def project_id(self):
        """Gets the project_id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The project_id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this PageActionRunProjectionContent.


        :param project_id: The project_id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def action_id(self):
        """Gets the action_id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The action_id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._action_id

    @action_id.setter
    def action_id(self, action_id):
        """Sets the action_id of this PageActionRunProjectionContent.


        :param action_id: The action_id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._action_id = action_id

    @property
    def run_state(self):
        """Gets the run_state of this PageActionRunProjectionContent.  # noqa: E501


        :return: The run_state of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._run_state

    @run_state.setter
    def run_state(self, run_state):
        """Sets the run_state of this PageActionRunProjectionContent.


        :param run_state: The run_state of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATED", "DEPLOYING", "RUNNING", "FINISHING", "COMPLETED", "DEPLOYMENT_FAILED", "FAILED", "CANCELLED", "UNKNOWN", "DEPLOYED", "HANDLING_ERROR"]  # noqa: E501
        if run_state not in allowed_values:
            raise ValueError(
                "Invalid value for `run_state` ({0}), must be one of {1}"  # noqa: E501
                .format(run_state, allowed_values)
            )

        self._run_state = run_state

    @property
    def action_type(self):
        """Gets the action_type of this PageActionRunProjectionContent.  # noqa: E501


        :return: The action_type of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """Sets the action_type of this PageActionRunProjectionContent.


        :param action_type: The action_type of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """
        allowed_values = ["SCRIPT", "REST_CALL", "REST_POLL", "FLOW", "VAULT", "CYBERARK"]  # noqa: E501
        if action_type not in allowed_values:
            raise ValueError(
                "Invalid value for `action_type` ({0}), must be one of {1}"  # noqa: E501
                .format(action_type, allowed_values)
            )

        self._action_type = action_type

    @property
    def run_project_id(self):
        """Gets the run_project_id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The run_project_id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._run_project_id

    @run_project_id.setter
    def run_project_id(self, run_project_id):
        """Sets the run_project_id of this PageActionRunProjectionContent.


        :param run_project_id: The run_project_id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._run_project_id = run_project_id

    @property
    def triggered_by(self):
        """Gets the triggered_by of this PageActionRunProjectionContent.  # noqa: E501


        :return: The triggered_by of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._triggered_by

    @triggered_by.setter
    def triggered_by(self, triggered_by):
        """Sets the triggered_by of this PageActionRunProjectionContent.


        :param triggered_by: The triggered_by of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._triggered_by = triggered_by

    @property
    def created_millis(self):
        """Gets the created_millis of this PageActionRunProjectionContent.  # noqa: E501


        :return: The created_millis of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: int
        """
        return self._created_millis

    @created_millis.setter
    def created_millis(self, created_millis):
        """Sets the created_millis of this PageActionRunProjectionContent.


        :param created_millis: The created_millis of this PageActionRunProjectionContent.  # noqa: E501
        :type: int
        """

        self._created_millis = created_millis

    @property
    def start_time_millis(self):
        """Gets the start_time_millis of this PageActionRunProjectionContent.  # noqa: E501


        :return: The start_time_millis of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: int
        """
        return self._start_time_millis

    @start_time_millis.setter
    def start_time_millis(self, start_time_millis):
        """Sets the start_time_millis of this PageActionRunProjectionContent.


        :param start_time_millis: The start_time_millis of this PageActionRunProjectionContent.  # noqa: E501
        :type: int
        """

        self._start_time_millis = start_time_millis

    @property
    def end_time_millis(self):
        """Gets the end_time_millis of this PageActionRunProjectionContent.  # noqa: E501


        :return: The end_time_millis of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: int
        """
        return self._end_time_millis

    @end_time_millis.setter
    def end_time_millis(self, end_time_millis):
        """Sets the end_time_millis of this PageActionRunProjectionContent.


        :param end_time_millis: The end_time_millis of this PageActionRunProjectionContent.  # noqa: E501
        :type: int
        """

        self._end_time_millis = end_time_millis

    @property
    def ebs_event_id(self):
        """Gets the ebs_event_id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The ebs_event_id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._ebs_event_id

    @ebs_event_id.setter
    def ebs_event_id(self, ebs_event_id):
        """Sets the ebs_event_id of this PageActionRunProjectionContent.


        :param ebs_event_id: The ebs_event_id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._ebs_event_id = ebs_event_id

    @property
    def action_version_id(self):
        """Gets the action_version_id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The action_version_id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._action_version_id

    @action_version_id.setter
    def action_version_id(self, action_version_id):
        """Sets the action_version_id of this PageActionRunProjectionContent.


        :param action_version_id: The action_version_id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._action_version_id = action_version_id

    @property
    def action_version_name(self):
        """Gets the action_version_name of this PageActionRunProjectionContent.  # noqa: E501


        :return: The action_version_name of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._action_version_name

    @action_version_name.setter
    def action_version_name(self, action_version_name):
        """Sets the action_version_name of this PageActionRunProjectionContent.


        :param action_version_name: The action_version_name of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._action_version_name = action_version_name

    @property
    def name(self):
        """Gets the name of this PageActionRunProjectionContent.  # noqa: E501


        :return: The name of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageActionRunProjectionContent.


        :param name: The name of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def runtime(self):
        """Gets the runtime of this PageActionRunProjectionContent.  # noqa: E501


        :return: The runtime of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._runtime

    @runtime.setter
    def runtime(self, runtime):
        """Sets the runtime of this PageActionRunProjectionContent.


        :param runtime: The runtime of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._runtime = runtime

    @property
    def id(self):
        """Gets the id of this PageActionRunProjectionContent.  # noqa: E501


        :return: The id of this PageActionRunProjectionContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageActionRunProjectionContent.


        :param id: The id of this PageActionRunProjectionContent.  # noqa: E501
        :type: str
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageActionRunProjectionContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageActionRunProjectionContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
